from setuptools import setup, find_packages


setup(
    name='fuzzing-seed-selection',
    description='Scripts supporting "Seed Selection for Successful Fuzzing"',
    author='Adrian Herrera',
    url='https://github.com/HexHive/fuzzing-seed-selection',
    platforms=['linux'],
    packages=find_packages(),
    include_package_data=True,
    scripts=[
        'bin/afl_cmin.py',
        'bin/afl_coverage_merge.py',
        'bin/afl_coverage_pca.py',
        'bin/expand_hdf5_coverage.py',
        'bin/fuzz.py',
        'bin/get_corpus.py',
        'bin/get_libs.py',
        'bin/llvm_cov_merge.py',
        'bin/llvm_cov_stats.py',
        'bin/qminset.py',
        'bin/replay_seeds.py',
        'bin/eval_maxsat.py',
        'bin/timestamp_afl.py',
        'bin/timestamp_honggfuzz.py',
        'bin/visualize_corpora.py',
    ],
    python_requires='>3.0',
    install_requires=[
        'h5py',
        'Jinja2',
        'lifelines',
        'matplotlib',
        'numpy',
        'osfclient',
        'pyelftools',
        'scikit-learn==0.23.2',
        'bootstrapped',
        'supervenn',
        'tabulate',
        'toml',
        'tqdm',
        'watchdog',
        'webdavclient3',
        'moonbeam @ git+https://gitlab.anu.edu.au/lunar/moonbeam.git#egg=moonbeam',
    ],
)
